module DataPath ( Inst, Zero, RegD, AluSrc, PcSrc, Mem2Reg, AluOp, RegWrite, MemWrite, MemRead, clk);

input[2:0]		AluOp;
input[1:0]		RegD, PcSrc, Mem2Reg;
input						AluSrc, RegWrite, MemWrite, MemRead, clk;

wire[31:0]		pcout, pcin, inst, pcplus4, rd1, rd2, wd, sigext, B, AluResult, memout, pcjump;
wire[4:0]			wr;
wire						temp, temp2;

output[31:0]	Inst;
output Zero;

assign Inst = inst;

Register 		pc( pcin, pcout, clk);
InstMem 			instmem( inst, pcout, clk);
fa32 					add4( pcplus4, temp, pcout, {{29{1'b0}}, 3'b100}, 1'b0);
Mux5_4 				regdest( wr, inst[20:16], inst[15:11], 5'b11111, 5'bxxxxx, RegD);
RegFile 			regfile( rd1, rd2, inst[25:21], inst[20:16], wr, wd, RegWrite, clk);
SignExtend signextend( sigext, inst[15:0]);
Mux32_2				alusrcB( B, rd2, sigext, AluSrc);
alu					myalu( AluResult, Zero, rd1, B, AluOp);
DataMem				memory( memout, AluResult, rd2, MemRead, MemWrite, clk);
Mux32_4				writedata( wd, AluResult, memout, pcplus4, {32{1'bx}}, Mem2Reg);
fa32 					add( pcjump, temp2, pcplus4, {sigext[29:0], 2'b00}, 1'b0);
Mux32_4				pcsource( pcin, pcplus4, pcjump, rd1, {pcplus4[31:28], inst[25:0], 2'b00}, PcSrc);

endmodule